unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, Spin, ComCtrls, Unit_cc;

type

  { TForm1 }

  TForm1 = class(TForm)
    CheckBox1: TCheckBox;
    Txt_HW: TEdit;
    Txt_X: TEdit;
    Txt_Y: TEdit;
    Frm_CC1: TFrm_CC;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Lbl_Id_Atleta: TLabel;
    Lbl_Atleta: TLabel;
    ListBox_Debug: TListBox;
    PageControl1: TPageControl;
    PageControl2: TPageControl;
    SpinEdit_Minuto: TSpinEdit;
    Splitter1: TSplitter;
    Splitter2: TSplitter;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    Timer_Resize: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure CheckBox1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure Frm_CC1Click(Sender: TObject);
    procedure Frm_CC1Resize(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer
      );
    procedure Timer_ResizeTimer(Sender: TObject);
  private
         procedure Disegna;
         procedure AtletaSelezionato(Sender: TObject);
  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
     Disegna;
end;

procedure TForm1.CheckBox1Change(Sender: TObject);
begin
     Self.Frm_CC1.ShowNames:=Self.CheckBox1.Checked;
     Disegna;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
     Self.Frm_CC1.OnClick:=@AtletaSelezionato;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  Self.Timer_Resize.Interval:=1000;
end;

procedure TForm1.Frm_CC1Click(Sender: TObject);
begin

end;

procedure TForm1.Frm_CC1Resize(Sender: TObject);
begin
     Self.Timer_Resize.Interval:=1000;
end;

procedure TForm1.Image1Click(Sender: TObject);
begin
     //recupero l'atleta selezionato
     Self.Lbl_Atleta.Caption:='';
     Self.Lbl_Id_Atleta.Caption:='-1';
     if Self.Frm_CC1.Last_id_selezionato>-1 then
     begin
        if Self.Frm_CC1.Last_tipo_selezionato=0 then
        begin
           Self.Lbl_Id_Atleta.Caption:=IntToStr(Self.Frm_CC1.ListaAtleti[Self.Frm_CC1.Last_id_selezionato].id);
           Self.Lbl_Atleta.Caption:=Self.Frm_CC1.ListaAtleti[Self.Frm_CC1.Last_id_selezionato].nome;
        end
        else
        begin
           Self.Lbl_Id_Atleta.Caption:=IntToStr(Self.Frm_CC1.ListaAvversari[Self.Frm_CC1.Last_id_selezionato].id);
           Self.Lbl_Atleta.Caption:=Self.Frm_CC1.ListaAvversari[Self.Frm_CC1.Last_id_selezionato].nome;
        end;
     end;

     Self.Txt_X.Text:=IntToStr(Self.Frm_CC1.Last_X) + '|' + IntToStr(Self.Frm_CC1.Last_X_Calcolato);
     Self.Txt_Y.Text:=IntToStr(Self.Frm_CC1.Last_Y) + '|' + IntToStr(Self.Frm_CC1.Last_Y_Calcolato);
end;

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
     Self.Txt_X.Text:=Inttostr(x);
     Self.Txt_Y.Text:=Inttostr(y);
end;

procedure TForm1.Timer_ResizeTimer(Sender: TObject);
begin
     Self.Timer_Resize.Interval:=0;
     Self.Disegna;
end;

procedure TForm1.Disegna;
var
   i: integer;
begin
  Self.Frm_CC1.Init;

  SetLength(Self.Frm_CC1.ListaAtleti,11);
  for i:=1 to 11 do
  begin
       with Self.Frm_CC1.ListaAtleti[i-1] do
       begin
            id:=i;
            nome:='atleta_' + IntToStr(i);
       end;
  end;

  SetLength(Self.Frm_CC1.ListaAvversari,11);
  for i:=1 to 11 do
  begin
       with Self.Frm_CC1.ListaAvversari[i-1] do
       begin
            id:=i;
            nome:='avversario_' + IntToStr(i);
       end;
  end;

  Self.Frm_CC1.SchieraDisposizione(0);
  Self.Frm_CC1.SchieraDisposizioneAvversaria(0);

  //dopo aver fatto il necessario visualizzo nella listbox i dati necessari per fare debug
  Self.ListBox_Debug.Clear;
  Self.ListBox_Debug.Items.Add('Data e ora:' + DateTimeToStr(now));
  Self.ListBox_Debug.Items.Add('Atleti: ');
  for i:=0 to Length(Self.Frm_CC1.ListaAtleti)-1 do
  begin
       Self.ListBox_Debug.Items.Add(Self.Frm_CC1.ListaAtleti[i].nome + ' | PH: ' + IntToStr(Self.Frm_CC1.ListaAtleti[i].PH) + ' | PW: ' + IntToStr(Self.Frm_CC1.ListaAtleti[i].PW) + ' | x1: ' + IntToStr(Self.Frm_CC1.ListaAtleti[i].x1) + ' | y1: ' + IntToStr(Self.Frm_CC1.ListaAtleti[i].y1) + ' | x2: ' + IntToStr(Self.Frm_CC1.ListaAtleti[i].x2) + ' | y2: ' + IntToStr(Self.Frm_CC1.ListaAtleti[i].y2));
  end;
  Self.ListBox_Debug.Items.Add('');
  Self.ListBox_Debug.Items.Add('Avversari: ');
  for i:=0 to Length(Self.Frm_CC1.ListaAvversari)-1 do
  begin
       Self.ListBox_Debug.Items.Add(Self.Frm_CC1.ListaAvversari[i].nome + ' | PH: ' + IntToStr(Self.Frm_CC1.ListaAvversari[i].PH) + ' | PW: ' + IntToStr(Self.Frm_CC1.ListaAvversari[i].PW) + ' | x1: ' + IntToStr(Self.Frm_CC1.ListaAvversari[i].x1) + ' | y1: ' + IntToStr(Self.Frm_CC1.ListaAvversari[i].y1) + ' | x2: ' + IntToStr(Self.Frm_CC1.ListaAvversari[i].x2) + ' | y2: ' + IntToStr(Self.Frm_CC1.ListaAvversari[i].y2));
  end;

  Self.Txt_HW.Text:=IntToStr(Self.Frm_CC1.Image1.Height) + '|' + IntToStr(Self.Frm_CC1.Image1.Width);
end;

procedure TForm1.AtletaSelezionato(Sender: TObject);
begin
     ShowMessage(IntToStr(Self.Frm_CC1.Last_id_selezionato));
end;

end.

