unit Unit_cc;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, ExtCtrls, Graphics;

type
    TDisposizioni = object
      desc: string;
      Po: integer;
      Di: integer;
      Ce: integer;
      At: integer;
      Pu: integer;
    end;

type
    TPersona = object
      id: integer;
      nome: string;
      x1: integer;
      y1: integer;
      x2: integer;
      y2: integer;
      PH: integer;
      PW: integer;
    end;

type

  { TFrm_CC }

  TFrm_CC = class(TFrame)
    Image1: TImage;
    ImageList1: TImageList;
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
         ListaDisposizioni: array of TDisposizioni;
         procedure CaricaDisposizioni;
  public
     ShowNames: boolean;
     Last_id_selezionato: integer;
     Last_tipo_selezionato: integer; //0 = atleta, 1 = avversario
     Last_X, Last_Y: integer;
     Last_X_Calcolato,Last_Y_Calcolato: integer;
     ListaAtleti: array of TPersona;
     ListaAvversari: array of TPersona;
     procedure Init;
     procedure SchieraDisposizione(indice: integer);
     procedure SchieraDisposizioneAvversaria(indice: integer);
  end;

  const
       Linea_Po =  8; //in %
       Linea_Di = 24; //in %
       Linea_Ce = 42; //in %
       Linea_At = 64; //in %
       Linea_Pu = 80; //in %

       Colore_Casa         = clRed;
       Colore_Avversario   = clGreen;
       Colore_Sfondo_Nomi  = clWhite;
       Colore_Testo_Nomi   = clBlack;
       Grandezza_Nomi      = 20;
       Spazio_Nome_Pallino = 18;

implementation

{$R *.lfm}

{ TFrm_CC }

procedure TFrm_CC.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
   i: integer;
   esci: boolean;
   x_calcolato, y_calcolato: double;
begin
     i:=0;
     esci:=false;
     Last_id_selezionato:=-1;
     Last_X:=X;
     Last_Y:=Y;

     while (i<Length(Self.ListaAtleti)) and (esci=false) do
     begin

          y_calcolato:=((100*Self.Image1.Height)/Self.ListaAtleti[i].PH);
          y_calcolato:=100/y_calcolato;

          x_calcolato:=Trunc((100*Self.Image1.Width)/Self.ListaAtleti[i].PW);
          x_calcolato:=100/x_calcolato;

          Self.Last_X_Calcolato:=Trunc(x_calcolato);
          Self.Last_Y_Calcolato:=Trunc(y_calcolato);

          if (Self.ListaAtleti[i].x1<=(x*x_calcolato)) and (Self.ListaAtleti[i].x2>=(x*x_calcolato)) then
             if (Self.ListaAtleti[i].y1<=(y*y_calcolato)) and (Self.ListaAtleti[i].y2>=(y*y_calcolato)) then
             begin
                  esci:=true;
                  Last_id_selezionato:=i;
                  Last_tipo_selezionato:=0;
             end;

          Inc(i);
     end;

     if not esci then
     begin
          i:=0;

          while (i<Length(Self.ListaAvversari)) and (esci=false) do
          begin

               y_calcolato:=((100*Self.Image1.Height)/Self.ListaAvversari[i].PH);
               y_calcolato:=100/y_calcolato;

               x_calcolato:=Trunc((100*Self.Image1.Width)/Self.ListaAvversari[i].PW);
               x_calcolato:=100/x_calcolato;

               Self.Last_X_Calcolato:=Trunc(x_calcolato);
               Self.Last_Y_Calcolato:=Trunc(y_calcolato);

               if (Self.ListaAvversari[i].x1<=(x*x_calcolato)) and (Self.ListaAvversari[i].x2>=(x*x_calcolato)) then
                  if (Self.ListaAvversari[i].y1<=(y*y_calcolato)) and (Self.ListaAvversari[i].y2>=(y*y_calcolato)) then
                  begin
                       esci:=true;
                       Last_id_selezionato:=i;
                       Last_tipo_selezionato:=1;
                  end;

               Inc(i);
          end;
     end;
end;

procedure TFrm_CC.CaricaDisposizioni;
begin
     SetLength(ListaDisposizioni,2);
     ListaDisposizioni[0].desc:='4-4-2';
     ListaDisposizioni[0].Po:=1;
     ListaDisposizioni[0].Di:=4;
     ListaDisposizioni[0].Ce:=4;
     ListaDisposizioni[0].At:=2;
     ListaDisposizioni[0].Pu:=0;


     ListaDisposizioni[1].desc:='4-3-2-1';
     ListaDisposizioni[1].Po:=1;
     ListaDisposizioni[1].Di:=4;
     ListaDisposizioni[1].Ce:=3;
     ListaDisposizioni[1].At:=2;
     ListaDisposizioni[1].Pu:=1;
end;

procedure TFrm_CC.Init;
begin
     CaricaDisposizioni;

     //recupero l'immagine di sfondo
     Self.ImageList1.GetBitmap(0, Self.Image1.Picture.Bitmap);
end;

procedure TFrm_CC.SchieraDisposizione(indice: integer);
var
   i, k: integer;
   delta_bordo: integer;
   posizione: double;
   posizione_disegno: integer;
   colore: TColor;
   raggio: integer;
   right_space: integer;
begin
     colore:=Colore_casa;
     raggio:=30;
     delta_bordo:=0;
     k:=0;

     //-------------------------------
     posizione:=( Self.Image1.Picture.Height-Trunc(((Self.Image1.Picture.Height/100)*delta_bordo)*2) ) / (ListaDisposizioni[indice].Po+1);
     right_space:=trunc(Self.Image1.Picture.Width/100)*Linea_Po;
     for i:=1 to ListaDisposizioni[indice].Po do
     begin


          posizione_disegno:=trunc( trunc((Self.Image1.Picture.Height/100)*delta_bordo) + (posizione*i));

          Self.Image1.Canvas.Brush.Color:=colore;
          Self.Image1.Canvas.Ellipse(right_space, posizione_disegno, right_space+raggio, posizione_disegno+raggio);



          Self.Image1.Canvas.Brush.Color:=Colore_Sfondo_Nomi;
          Self.Image1.Canvas.Font.Color :=Colore_Testo_Nomi;
          Self.Image1.Canvas.Font.Height:=Grandezza_Nomi;
          if Self.ShowNames then
             Self.Image1.Canvas.TextOut(right_space, posizione_disegno - (Self.Image1.Canvas.Font.Height+Spazio_Nome_Pallino), Self.ListaAtleti[k].nome);
          Self.ListaAtleti[k].x1:=right_space;
          Self.ListaAtleti[k].y1:=posizione_disegno;
          Self.ListaAtleti[k].x2:=right_space+raggio;
          Self.ListaAtleti[k].y2:=posizione_disegno+raggio;
          Self.ListaAtleti[k].PH:=Self.Image1.Picture.Height;
          Self.ListaAtleti[k].PW:=Self.Image1.Picture.Width;

          Inc(k);
     end;

     //-------------------------------
     posizione:=( Self.Image1.Picture.Height-Trunc(((Self.Image1.Picture.Height/100)*delta_bordo)*2) ) / (ListaDisposizioni[indice].Di+1);
     right_space:=trunc(Self.Image1.Picture.Width/100)*Linea_Di;
     for i:=1 to ListaDisposizioni[indice].Di do
     begin


          posizione_disegno:=trunc( trunc((Self.Image1.Picture.Height/100)*delta_bordo) + (posizione*i));

          Self.Image1.Canvas.Brush.Color:=colore;
          Self.Image1.Canvas.Ellipse(right_space, posizione_disegno, right_space+raggio, posizione_disegno+raggio);

          Self.Image1.Canvas.Brush.Color:=Colore_Sfondo_Nomi;
          Self.Image1.Canvas.Font.Color :=Colore_Testo_Nomi;
          Self.Image1.Canvas.Font.Height:=Grandezza_Nomi;
          if Self.ShowNames then
             Self.Image1.Canvas.TextOut(right_space, posizione_disegno - (Self.Image1.Canvas.Font.Height+Spazio_Nome_Pallino), Self.ListaAtleti[k].nome);
          Self.ListaAtleti[k].x1:=right_space;
          Self.ListaAtleti[k].y1:=posizione_disegno;
          Self.ListaAtleti[k].x2:=right_space+raggio;
          Self.ListaAtleti[k].y2:=posizione_disegno+raggio;
          Self.ListaAtleti[k].PH:=Self.Image1.Picture.Height;
          Self.ListaAtleti[k].PW:=Self.Image1.Picture.Width;

          Inc(k);

     end;

     //-------------------------------
     posizione:=( Self.Image1.Picture.Height-Trunc(((Self.Image1.Picture.Height/100)*delta_bordo)*2) ) / (ListaDisposizioni[indice].Ce+1);
     right_space:=trunc(Self.Image1.Picture.Width/100)*Linea_Ce;
     for i:=1 to ListaDisposizioni[indice].Ce do
     begin


          posizione_disegno:=trunc( trunc((Self.Image1.Picture.Height/100)*delta_bordo) + (posizione*i));

          Self.Image1.Canvas.Brush.Color:=colore;
          Self.Image1.Canvas.Ellipse(right_space, posizione_disegno, right_space+raggio, posizione_disegno+raggio);

          Self.Image1.Canvas.Brush.Color:=Colore_Sfondo_Nomi;
          Self.Image1.Canvas.Font.Color :=Colore_Testo_Nomi;
          Self.Image1.Canvas.Font.Height:=Grandezza_Nomi;
          if Self.ShowNames then
             Self.Image1.Canvas.TextOut(right_space, posizione_disegno - (Self.Image1.Canvas.Font.Height+Spazio_Nome_Pallino), Self.ListaAtleti[k].nome);
          Self.ListaAtleti[k].x1:=right_space;
          Self.ListaAtleti[k].y1:=posizione_disegno;
          Self.ListaAtleti[k].x2:=right_space+raggio;
          Self.ListaAtleti[k].y2:=posizione_disegno+raggio;
          Self.ListaAtleti[k].PH:=Self.Image1.Picture.Height;
          Self.ListaAtleti[k].PW:=Self.Image1.Picture.Width;

          Inc(k);

     end;

     //-------------------------------
     posizione:=( Self.Image1.Picture.Height-Trunc(((Self.Image1.Picture.Height/100)*delta_bordo)*2) ) / (ListaDisposizioni[indice].At+1);
     right_space:=trunc(Self.Image1.Picture.Width/100)*Linea_At;
     for i:=1 to ListaDisposizioni[indice].At do
     begin


          posizione_disegno:=trunc( trunc((Self.Image1.Picture.Height/100)*delta_bordo) + (posizione*i));

          Self.Image1.Canvas.Brush.Color:=colore;
          Self.Image1.Canvas.Ellipse(right_space, posizione_disegno, right_space+raggio, posizione_disegno+raggio);

          Self.Image1.Canvas.Brush.Color:=Colore_Sfondo_Nomi;
          Self.Image1.Canvas.Font.Color :=Colore_Testo_Nomi;
          Self.Image1.Canvas.Font.Height:=Grandezza_Nomi;
          if Self.ShowNames then
             Self.Image1.Canvas.TextOut(right_space, posizione_disegno - (Self.Image1.Canvas.Font.Height+Spazio_Nome_Pallino), Self.ListaAtleti[k].nome);
          Self.ListaAtleti[k].x1:=right_space;
          Self.ListaAtleti[k].y1:=posizione_disegno;
          Self.ListaAtleti[k].x2:=right_space+raggio;
          Self.ListaAtleti[k].y2:=posizione_disegno+raggio;
          Self.ListaAtleti[k].PH:=Self.Image1.Picture.Height;
          Self.ListaAtleti[k].PW:=Self.Image1.Picture.Width;

          Inc(k);

     end;

     //-------------------------------
     posizione:=( Self.Image1.Picture.Height-Trunc(((Self.Image1.Picture.Height/100)*delta_bordo)*2) ) / (ListaDisposizioni[indice].Pu+1);
     right_space:=trunc(Self.Image1.Picture.Width/100)*Linea_Pu;
     for i:=1 to ListaDisposizioni[indice].Pu do
     begin


          posizione_disegno:=trunc( trunc((Self.Image1.Picture.Height/100)*delta_bordo) + (posizione*i));

          Self.Image1.Canvas.Brush.Color:=colore;
          Self.Image1.Canvas.Ellipse(right_space, posizione_disegno, right_space+raggio, posizione_disegno+raggio);

          Self.Image1.Canvas.Brush.Color:=Colore_Sfondo_Nomi;
          Self.Image1.Canvas.Font.Color :=Colore_Testo_Nomi;
          Self.Image1.Canvas.Font.Height:=Grandezza_Nomi;
          if Self.ShowNames then
             Self.Image1.Canvas.TextOut(right_space, posizione_disegno - (Self.Image1.Canvas.Font.Height+Spazio_Nome_Pallino), Self.ListaAtleti[k].nome);
          Self.ListaAtleti[k].x1:=right_space;
          Self.ListaAtleti[k].y1:=posizione_disegno;
          Self.ListaAtleti[k].x2:=right_space+raggio;
          Self.ListaAtleti[k].y2:=posizione_disegno+raggio;
          Self.ListaAtleti[k].PH:=Self.Image1.Picture.Height;
          Self.ListaAtleti[k].PW:=Self.Image1.Picture.Width;

          Inc(k);

     end;
end;

procedure TFrm_CC.SchieraDisposizioneAvversaria(indice: integer);
var
   i,k : integer;
   delta_bordo: integer;
   posizione: double;
   posizione_disegno: integer;
   colore: TColor;
   raggio: integer;
   right_space: integer;
begin
     colore:=Colore_Avversario;
     raggio:=30;
     delta_bordo:=0;
     k:=0;

     //-------------------------------
     posizione:=( Self.Image1.Picture.Height-Trunc(((Self.Image1.Picture.Height/100)*delta_bordo)*2) ) / (ListaDisposizioni[indice].Po+1);
     right_space:=trunc(Self.Image1.Picture.Width/100)*(100-Linea_Po);
     for i:=1 to ListaDisposizioni[indice].Po do
     begin


          posizione_disegno:=trunc( trunc((Self.Image1.Picture.Height/100)*delta_bordo) + (posizione*i));

          Self.Image1.Canvas.Brush.Color:=colore;
          Self.Image1.Canvas.Ellipse(right_space, posizione_disegno, right_space+raggio, posizione_disegno+raggio);

          Self.Image1.Canvas.Brush.Color:=Colore_Sfondo_Nomi;
          Self.Image1.Canvas.Font.Color :=Colore_Testo_Nomi;
          Self.Image1.Canvas.Font.Height:=Grandezza_Nomi;
          if Self.ShowNames then
             Self.Image1.Canvas.TextOut(right_space, posizione_disegno - (Self.Image1.Canvas.Font.Height+Spazio_Nome_Pallino), Self.ListaAvversari[k].nome);
          Self.ListaAvversari[k].x1:=right_space;
          Self.ListaAvversari[k].y1:=posizione_disegno;
          Self.ListaAvversari[k].x2:=right_space+raggio;
          Self.ListaAvversari[k].y2:=posizione_disegno+raggio;
          Self.ListaAvversari[k].PH:=Self.Image1.Picture.Height;
          Self.ListaAvversari[k].PW:=Self.Image1.Picture.Width;

          Inc(k);


     end;

     //-------------------------------
     posizione:=( Self.Image1.Picture.Height-Trunc(((Self.Image1.Picture.Height/100)*delta_bordo)*2) ) / (ListaDisposizioni[indice].Di+1);
     right_space:=trunc(Self.Image1.Picture.Width/100)*(100-Linea_Di);
     for i:=1 to ListaDisposizioni[indice].Di do
     begin


          posizione_disegno:=trunc( trunc((Self.Image1.Picture.Height/100)*delta_bordo) + (posizione*i));

          Self.Image1.Canvas.Brush.Color:=colore;
          Self.Image1.Canvas.Ellipse(right_space, posizione_disegno, right_space+raggio, posizione_disegno+raggio);

          Self.Image1.Canvas.Brush.Color:=Colore_Sfondo_Nomi;
          Self.Image1.Canvas.Font.Color :=Colore_Testo_Nomi;
          Self.Image1.Canvas.Font.Height:=Grandezza_Nomi;
          if Self.ShowNames then
             Self.Image1.Canvas.TextOut(right_space, posizione_disegno + (Self.Image1.Canvas.Font.Height+Spazio_Nome_Pallino), Self.ListaAvversari[k].nome);
          Self.ListaAvversari[k].x1:=right_space;
          Self.ListaAvversari[k].y1:=posizione_disegno;
          Self.ListaAvversari[k].x2:=right_space+raggio;
          Self.ListaAvversari[k].y2:=posizione_disegno+raggio;
          Self.ListaAvversari[k].PH:=Self.Image1.Picture.Height;
          Self.ListaAvversari[k].PW:=Self.Image1.Picture.Width;

          Inc(k);

     end;

     //-------------------------------
     posizione:=( Self.Image1.Picture.Height-Trunc(((Self.Image1.Picture.Height/100)*delta_bordo)*2) ) / (ListaDisposizioni[indice].Ce+1);
     right_space:=trunc(Self.Image1.Picture.Width/100)*(100-Linea_Ce);
     for i:=1 to ListaDisposizioni[indice].Ce do
     begin


          posizione_disegno:=trunc( trunc((Self.Image1.Picture.Height/100)*delta_bordo) + (posizione*i));

          Self.Image1.Canvas.Brush.Color:=colore;
          Self.Image1.Canvas.Ellipse(right_space, posizione_disegno, right_space+raggio, posizione_disegno+raggio);

          Self.Image1.Canvas.Brush.Color:=Colore_Sfondo_Nomi;
          Self.Image1.Canvas.Font.Color :=Colore_Testo_Nomi;
          Self.Image1.Canvas.Font.Height:=Grandezza_Nomi;
          if Self.ShowNames then
             Self.Image1.Canvas.TextOut(right_space, posizione_disegno + (Self.Image1.Canvas.Font.Height+Spazio_Nome_Pallino), Self.ListaAvversari[k].nome);
          Self.ListaAvversari[k].x1:=right_space;
          Self.ListaAvversari[k].y1:=posizione_disegno;
          Self.ListaAvversari[k].x2:=right_space+raggio;
          Self.ListaAvversari[k].y2:=posizione_disegno+raggio;
          Self.ListaAvversari[k].PH:=Self.Image1.Picture.Height;
          Self.ListaAvversari[k].PW:=Self.Image1.Picture.Width;

          Inc(k);
     end;

     //-------------------------------
     posizione:=( Self.Image1.Picture.Height-Trunc(((Self.Image1.Picture.Height/100)*delta_bordo)*2) ) / (ListaDisposizioni[indice].At+1);
     right_space:=trunc(Self.Image1.Picture.Width/100)*(100-Linea_At);
     for i:=1 to ListaDisposizioni[indice].At do
     begin


          posizione_disegno:=trunc( trunc((Self.Image1.Picture.Height/100)*delta_bordo) + (posizione*i));

          Self.Image1.Canvas.Brush.Color:=colore;
          Self.Image1.Canvas.Ellipse(right_space, posizione_disegno, right_space+raggio, posizione_disegno+raggio);

          Self.Image1.Canvas.Brush.Color:=Colore_Sfondo_Nomi;
          Self.Image1.Canvas.Font.Color :=Colore_Testo_Nomi;
          Self.Image1.Canvas.Font.Height:=Grandezza_Nomi;
          if Self.ShowNames then
             Self.Image1.Canvas.TextOut(right_space, posizione_disegno + (Self.Image1.Canvas.Font.Height+Spazio_Nome_Pallino), Self.ListaAvversari[k].nome);
          Self.ListaAvversari[k].x1:=right_space;
          Self.ListaAvversari[k].y1:=posizione_disegno;
          Self.ListaAvversari[k].x2:=right_space+raggio;
          Self.ListaAvversari[k].y2:=posizione_disegno+raggio;
          Self.ListaAvversari[k].PH:=Self.Image1.Picture.Height;
          Self.ListaAvversari[k].PW:=Self.Image1.Picture.Width;

          Inc(k);
     end;

     //-------------------------------
     posizione:=( Self.Image1.Picture.Height-Trunc(((Self.Image1.Picture.Height/100)*delta_bordo)*2) ) / (ListaDisposizioni[indice].Pu+1);
     right_space:=trunc(Self.Image1.Picture.Width/100)*(100-Linea_Pu);
     for i:=1 to ListaDisposizioni[indice].Pu do
     begin


          posizione_disegno:=trunc( trunc((Self.Image1.Picture.Height/100)*delta_bordo) + (posizione*i));

          Self.Image1.Canvas.Brush.Color:=colore;
          Self.Image1.Canvas.Ellipse(right_space, posizione_disegno, right_space+raggio, posizione_disegno+raggio);

          Self.Image1.Canvas.Brush.Color:=Colore_Sfondo_Nomi;
          Self.Image1.Canvas.Font.Color :=Colore_Testo_Nomi;
          Self.Image1.Canvas.Font.Height:=Grandezza_Nomi;
          if Self.ShowNames then
             Self.Image1.Canvas.TextOut(right_space, posizione_disegno + (Self.Image1.Canvas.Font.Height+Spazio_Nome_Pallino), Self.ListaAvversari[k].nome);
          Self.ListaAvversari[k].x1:=right_space;
          Self.ListaAvversari[k].y1:=posizione_disegno;
          Self.ListaAvversari[k].x2:=right_space+raggio;
          Self.ListaAvversari[k].y2:=posizione_disegno+raggio;
          Self.ListaAvversari[k].PH:=Self.Image1.Picture.Height;
          Self.ListaAvversari[k].PW:=Self.Image1.Picture.Width;

          Inc(k);
     end;
end;

end.

